Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1584)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -111,5 +111,6 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: rad_net_av, rad_sw_in_av
+        ONLY: rad_net, rad_net_av, rad_lw_in, rad_lw_in_av, rad_lw_out,        &
+              rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
 
     USE random_function_mod,                                                   &
@@ -333,5 +334,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '4.0'
+       binary_version = '4.1'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -812,4 +813,12 @@
                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'rad_net' )
+                   IF ( .NOT. ALLOCATED( rad_net ) )  THEN
+                      ALLOCATE( rad_net(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   rad_net(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'rad_net_av' )
                    IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
@@ -819,12 +828,67 @@
                    rad_net_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                CASE ( 'rad_lw_in' )
+                   IF ( .NOT. ALLOCATED( rad_lw_in ) )  THEN
+                      ALLOCATE( rad_lw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_in_av' )
+                   IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  THEN
+                      ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_out' )
+                   IF ( .NOT. ALLOCATED( rad_lw_out ) )  THEN
+                      ALLOCATE( rad_lw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_out_av' )
+                   IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  THEN
+                      ALLOCATE( rad_lw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_in' )
+                   IF ( .NOT. ALLOCATED( rad_sw_in ) )  THEN
+                      ALLOCATE( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_in(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'rad_sw_in_av' )
                    IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
-                      ALLOCATE( rad_sw_in_av(nysg:nyng,nxlg:nxrg) )
-                   ENDIF  
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   rad_sw_in_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                      ALLOCATE( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_in_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_out' )
+                   IF ( .NOT. ALLOCATED( rad_sw_out ) )  THEN
+                      ALLOCATE( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_out(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_out_av' )
+                   IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  THEN
+                      ALLOCATE( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'random_iv' )  ! still unresolved issue
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1584)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -162,4 +162,7 @@
 
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY: time_radiation
 
     USE statistics,                                                            &
@@ -609,4 +612,6 @@
           CASE ( 'time_dvrp' )
              READ ( 13 )  time_dvrp
+          CASE ( 'time_radiation' )
+             READ ( 13 )  time_radiation
           CASE ( 'time_restart' )
              READ ( 13 )  time_restart
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1584)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -112,5 +112,7 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av
+        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av, rad_sw_out,       &
+               rad_sw_out_av, rad_lw_in, rad_lw_in_av, rad_lw_out,             &
+               rad_lw_out_av
 
     IMPLICIT NONE
@@ -326,9 +328,27 @@
                 rad_net_av = 0.0_wp
 
-             CASE ( 'rad_sw_in*' )
+             CASE ( 'rad_lw_in' )
+                IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  THEN
+                   ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_lw_in_av = 0.0_wp
+
+             CASE ( 'rad_lw_out' )
+                IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  THEN
+                   ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_lw_out_av = 0.0_wp
+
+             CASE ( 'rad_sw_in' )
                 IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
-                   ALLOCATE( rad_sw_in_av(nysg:nyng,nxlg:nxrg) )
+                   ALLOCATE( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 ENDIF
                 rad_sw_in_av = 0.0_wp
+
+             CASE ( 'rad_sw_out' )
+                IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  THEN
+                   ALLOCATE( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_sw_out_av = 0.0_wp
 
              CASE ( 'rho' )
@@ -732,8 +752,38 @@
              ENDDO
 
-          CASE ( 'rad_sw_in*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   rad_sw_in_av(j,i) = rad_sw_in_av(j,i) + rad_sw_in(j,i)
+          CASE ( 'rad_lw_in' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_in_av(k,j,i) = rad_lw_in_av(k,j,i) + rad_lw_in(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_lw_out' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_out_av(k,j,i) = rad_lw_out_av(k,j,i) + rad_lw_out(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+
+          CASE ( 'rad_sw_in' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_in_av(k,j,i) = rad_sw_in_av(k,j,i) + rad_sw_in(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_out' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_out_av(k,j,i) = rad_sw_out_av(k,j,i) + rad_sw_out(k,j,i)
+                   ENDDO
                 ENDDO
              ENDDO
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1584)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Moved call of radiation scheme. Added support for RRTM
 ! 
 ! Former revisions:
@@ -226,6 +226,6 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: dt_radiation, irad_scheme, radiation, radiation_clearsky,        &
-              radiation_constant, radiation_rrtm, time_radiation
+        ONLY: dt_radiation, radiation, radiation_clearsky,                     &
+              radiation_rrtmg, radiation_scheme, time_radiation
 
     USE statistics,                                                            &
@@ -362,4 +362,23 @@
           ENDIF
 
+          IF ( radiation .AND. intermediate_timestep_count                     &
+               == intermediate_timestep_count_max  )  THEN
+
+               time_radiation = time_radiation + dt_3d
+
+             IF ( time_radiation >= dt_radiation )  THEN
+
+                CALL cpu_log( log_point(50), 'radiation', 'start' )
+
+                time_radiation = time_radiation - dt_radiation
+                IF ( radiation_scheme == 'clear-sky' )  THEN
+                   CALL radiation_clearsky
+                ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
+                   CALL radiation_rrtmg
+                ENDIF
+
+                CALL cpu_log( log_point(50), 'radiation', 'stop' )
+             ENDIF
+          ENDIF
 !
 !--       Solve the prognostic equations. A fast cache optimized version with
@@ -597,22 +616,4 @@
 !--       2) run soil model 
           IF ( land_surface )  THEN
-
-             time_radiation = time_radiation + dt_3d
-
-             IF ( time_radiation >= dt_radiation )  THEN
-
-                CALL cpu_log( log_point(50), 'radiation', 'start' )
-
-                time_radiation = time_radiation - dt_radiation
-                IF ( irad_scheme == 0 )  THEN
-                   CALL radiation_constant              
-                ELSEIF ( irad_scheme == 1 )  THEN
-                   CALL radiation_clearsky
-                ELSEIF ( irad_scheme == 2 )  THEN
-                   CALL radiation_rrtm
-                ENDIF
-
-                CALL cpu_log( log_point(50), 'radiation', 'stop' )
-             ENDIF
 
              CALL cpu_log( log_point(54), 'land_surface', 'start' )
@@ -693,4 +694,5 @@
              !$acc update device( vpt ) 
           ENDIF 
+
 !
 !--       Compute the diffusion quantities
Index: palm/trunk/SOURCE/user_init_land_surface.f90
===================================================================
--- palm/trunk/SOURCE/user_init_land_surface.f90	(revision 1584)
+++ palm/trunk/SOURCE/user_init_land_surface.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changed description text
 ! 
 ! Former revisions:
@@ -52,5 +52,5 @@
 
 !
-!-- Here the user-defined grid initializing actions follow:
+!-- Here the user-defined land surface initialization actions follow:
 
 
Index: palm/trunk/SOURCE/user_init_radiation.f90
===================================================================
--- palm/trunk/SOURCE/user_init_radiation.f90	(revision 1585)
+++ palm/trunk/SOURCE/user_init_radiation.f90	(revision 1585)
@@ -0,0 +1,56 @@
+ SUBROUTINE user_init_radiation
+
+!--------------------------------------------------------------------------------!
+! This file is part of PALM.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms
+! of the GNU General Public License as published by the Free Software Foundation,
+! either version 3 of the License, or (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2014 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! Initial revision
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! 
+! Description:
+! ------------
+! Execution of user-defined actions to initiate the radiation model
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    
+    USE control_parameters
+    
+    USE indices
+    
+    USE kinds
+
+    USE radiation_model_mod
+    
+    USE user
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: i   !: running index
+    INTEGER(iwp) :: j   !: running index
+
+!
+!-- Here the user-defined radiation initialization actions follow:
+
+
+
+ END SUBROUTINE user_init_radiation
+
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1584)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -102,5 +102,7 @@
     
     USE radiation_model_mod,                                                   &
-        ONLY: radiation, rad_net_av, rad_sw_in_av
+        ONLY: radiation, rad_net, rad_net_av, rad_lw_in, rad_lw_in_av,         &
+              rad_lw_out, rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out,  &
+              rad_sw_out_av
 
     USE random_function_mod,                                                   &
@@ -124,5 +126,5 @@
 !
 !-- Write arrays.
-    binary_version = '4.0'
+    binary_version = '4.1'
 
     WRITE ( 14 )  binary_version
@@ -262,10 +264,34 @@
        ENDIF 
     ENDIF
+    IF ( ALLOCATED( rad_net ) )  THEN
+       WRITE ( 14 )  'rad_net             ';  WRITE ( 14 )  rad_net  
+    ENDIF
     IF ( radiation )  THEN
        IF ( ALLOCATED( rad_net_av ) )  THEN
           WRITE ( 14 )  'rad_net_av          ';  WRITE ( 14 )  rad_net_av  
        ENDIF  
+       IF ( ALLOCATED( rad_lw_in ) )  THEN
+          WRITE ( 14 )  'rad_lw_in           ';  WRITE ( 14 )  rad_lw_in  
+       ENDIF
+       IF ( ALLOCATED( rad_lw_in_av ) )  THEN
+          WRITE ( 14 )  'rad_lw_in_av        ';  WRITE ( 14 )  rad_lw_in_av  
+       ENDIF 
+       IF ( ALLOCATED( rad_lw_out ) )  THEN
+          WRITE ( 14 )  'rad_lw_out          ';  WRITE ( 14 )  rad_lw_out 
+       ENDIF 
+       IF ( ALLOCATED( rad_lw_out_av ) )  THEN
+          WRITE ( 14 )  'rad_lw_out_av       ';  WRITE ( 14 )  rad_lw_out_av  
+       ENDIF 
+       IF ( ALLOCATED( rad_sw_in ) )  THEN
+          WRITE ( 14 )  'rad_sw_in           ';  WRITE ( 14 )  rad_sw_in  
+       ENDIF 
        IF ( ALLOCATED( rad_sw_in_av ) )  THEN
-          WRITE ( 14 )  'rad_sw_in_av          ';  WRITE ( 14 )  rad_sw_in_av  
+          WRITE ( 14 )  'rad_sw_in_av        ';  WRITE ( 14 )  rad_sw_in_av  
+       ENDIF 
+       IF ( ALLOCATED( rad_sw_out ) )  THEN
+          WRITE ( 14 )  'rad_sw_out          ';  WRITE ( 14 )  rad_sw_out  
+       ENDIF 
+       IF ( ALLOCATED( rad_sw_out_av ) )  THEN
+          WRITE ( 14 )  'rad_sw_out_av       ';  WRITE ( 14 )  rad_sw_out_av  
        ENDIF 
     ENDIF
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 1584)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -147,4 +147,7 @@
     
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY: time_radiation
 
     USE statistics,                                                            &
@@ -522,4 +525,6 @@
     WRITE ( 14 )  'time_dvrp                     '
     WRITE ( 14 )  time_dvrp
+    WRITE ( 14 )  'time_radiation                '
+    WRITE ( 14 )  time_radiation
     WRITE ( 14 )  'time_restart                  '
     WRITE ( 14 )  time_restart
